Name:           gringo
Version:        4.3.0
Release:        1%{?dist}
Summary:        Grounding tools for (disjunctive) logic programs

Group:          Applications/Engineering
License:        GPLv3
URL:            http://potassco.sourceforge.net
Source0:        http://downloads.sourceforge.net/potassco/%{name}-%{version}-source.tar.gz
Patch0:         %{name}-4.3.0-limits-include.patch
Patch1:         %{name}-4.3.0-unbundle-clasp.patch
Patch2:         %{name}-4.3.0-warnings-check-defined.patch

BuildRequires:  bison
BuildRequires:  clasp-devel
BuildRequires:  clasp-static
BuildRequires:  cppunit-devel
BuildRequires:  dos2unix
BuildRequires:  lua-devel
BuildRequires:  python2-devel
BuildRequires:  re2c
BuildRequires:  scons

%package examples
Summary:        Examples for %{name}, a grounding tool for logic problems
Requires:       %{name} == %{version}-%{release}
BuildArch:      noarch

%package devel
Summary:        Static library and headers for %{name}
Provides:       %{name}-static = %{version}-%{release}
Requires:       clasp-devel
Requires:       lua-devel
Requires:       python2-devel

%description
Current answer set solvers work on variable-free programs. Hence, a grounder is
needed that, given an input program with first-order variables, computes an
equivalent ground (variable-free) program. Gringo is such a grounder. Its
output can be processed further with clasp, claspar, or claspfolio.

%description examples
This package contains the examples distributed with %{name} %{version}.

%description devel
This package contains the static library and headers for %{name} %{version}.

%prep
%setup -qn %{name}-%{version}-source
%patch0 -p1
%patch1 -p1
%patch2 -p0

# Use system clasp
rm -rf libclasp

# Fix some encodings
for f in `find examples -name '*.lp'`; do
    dos2unix $f
done

# Fix some FSF addresses in sources
for f in `find libprogram_opts -name '*.cpp'` `find libprogram_opts -name '*.h'`; do
    sed -i 's/59 Temple Place, Suite 330, Boston, MA  02111-1307  USA/51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA/' $f
done

%build
scons %{?_smp_mflags} configure WITH_TBB="tbb" WITH_LUA="lua" WITH_CPPUNIT="cppunit" WITH_PYTHON="python2.7" CPPPATH="/usr/include/python2.7/" CXXFLAGS="%{optflags} -std=c++11 -DDEBUG -D_DEBUG" LINKFLAGS="%{optflags} -std=c++11 -DDEBUG -D_DEBUG" --build-dir=debug
scons %{?_smp_mflags} %{name} --build-dir=debug

%install
install -m0755 -D build/debug/%{name} %{buildroot}%{_bindir}/%{name}
install -m0644 -D build/debug/lib%{name}.a %{buildroot}%{_libdir}/lib%{name}.a
mkdir -p %{buildroot}%{_includedir}
cp -a lib%{name}/%{name} %{buildroot}%{_includedir}/%{name}

%check
scons %{?_smp_mflags} test --build-dir=debug

%files
%doc CHANGES COPYING NOTES README
%{_bindir}/%{name}

%files examples
%doc examples

%files devel
%{_libdir}/lib%{name}.a
%{_includedir}/%{name}

%changelog
* Wed Apr 23 2014 Scott K Logan <logans@cottsay.net> - 4.3.0-1
- Initial package
